@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashAPartMTK
set /A failure_count=0


    REM This is a discriminant for logo image.
    set /A A=0
    if exist logo.bin set /A A+=1
    if exist logo.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: logo.bin and logo.img exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!skip_error_prompt!" NEQ "1" (
            echo.
            echo Warning: Logo image does not exist, but your device contain this partition, skip flashing.
        )
    )
    REM if %A% EQU 1
    if exist logo.bin (
        echo.
        echo ------ Flashing Logo image ------
        %fastboot% -s %serial_number% flash logo%slotsuffix% logo.bin
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo Error: fastboot flash logo failed^^!
            echo ------------------------------
        )
    ) else (
        if exist logo.img (
            echo.
            echo ------ Flashing Logo image ------
            !fastboot! -s !serial_number! flash logo!slotsuffix! logo.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash logo failed^^!
                echo ------------------------------
            )
        )
    )

    if "%device_has_vbmeta%" EQU "1" (
        if exist vbmeta.img (
            echo.
            echo ------ Flashing VBMeta image ------
            !fastboot! -s !serial_number! flash vbmeta!slotsuffix! vbmeta.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vbmeta failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: VBMeta image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_vbmeta_system%" EQU "1" (
        if exist vbmeta_system.img (
            echo.
            echo ------ Flashing VBMeta_System image ------
            !fastboot! -s !serial_number! flash vbmeta_system!slotsuffix! vbmeta_system.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vbmeta_system failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: VBMeta_System image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_cam_vpu1%" EQU "1" (
        if exist cam_vpu1.img (
            echo.
            echo ------ Flashing cam_vpu1 image ------
            !fastboot! -s !serial_number! flash cam_vpu1!slotsuffix! cam_vpu1.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash cam_vpu1 failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: cam_vpu1 image does not exist. Skip flashing...
            )
        )
        if exist cam_vpu2.img (
            echo.
            echo ------ Flashing cam_vpu2 image ------
            !fastboot! -s !serial_number! flash cam_vpu2!slotsuffix! cam_vpu2.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash cam_vpu2 failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: cam_vpu2 image does not exist. Skip flashing...
            )
        )
        if exist cam_vpu3.img (
            echo.
            echo ------ Flashing cam_vpu3 image ------
            !fastboot! -s !serial_number! flash cam_vpu3!slotsuffix! cam_vpu3.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash cam_vpu3 failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: cam_vpu3 image does not exist. Skip flashing...
            )
        )
    )

    if "%device_has_mcf_ota%" EQU "1" (
        if exist mcf_ota.img (
            echo.
            echo ------ Flashing MCF_OTA image ------
            !fastboot! -s !serial_number! flash mcf_ota!slotsuffix! mcf_ota.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Error: fastboot flash mcf_ota failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: MCF_OTA image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

    if "%device_has_audio_dsp%" EQU "1" (
        if exist audio_dsp.img (
            echo.
            echo ------ Flashing AUDIO DSP image ------
            !fastboot! -s !serial_number! flash audio_dsp!slotsuffix! audio_dsp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash audio_dsp failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: AUDIO DSP image does not exist. Skip flashing...
            )
        )
    )

    if "%device_has_ccu%" EQU "1" (
        if exist ccu.img (
            echo.
            echo ------ Flashing CCU image ------
            !fastboot! -s !serial_number! flash ccu!slotsuffix! ccu.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash ccu failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: CCU image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

    if "%device_has_apusys%" EQU "1" (
        if exist apusys.img (
            echo.
            echo ------ Flashing APUSYS image ------
            !fastboot! -s !serial_number! flash apusys!slotsuffix! apusys.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash apusys failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: APUSYS image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

    if exist boot.img (
        echo.
        echo ------ Flashing Boot image ------
        %fastboot% -s %serial_number% flash boot%slotsuffix% boot.img
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
                echo Error: fastboot flash boot failed^^!
            echo ------------------------------
        )
    ) else (
        if "!skip_error_prompt!" NEQ "1" (
            echo.
            echo Warning: Boot image does not exist, but your device contain this partition, skip flashing.
        )
    )

    if "%device_has_init_boot%" EQU "1" (
        if exist init_boot.img (
            echo.
            echo ------ Flashing Init_Boot image ------
            !fastboot! -s !serial_number! flash init_boot!slotsuffix! init_boot.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash init_boot failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: Init_Boot image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_vendor_boot%" EQU "1" (
        if exist vendor_boot.img (
            echo.
            echo ------ Flashing Vendor_Boot image ------
            !fastboot! -s !serial_number! flash vendor_boot!slotsuffix! vendor_boot.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vendor_boot failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Note: Vendor_Boot image does not exist. Skipping flash...
            )
        )
    )

    if "%device_has_dtb%" EQU "1" (
        if exist dtb.img (
            echo.
            echo ------ Flashing DTB image ------
            !fastboot! -s !serial_number! flash dtb!slotsuffix! dtb.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash dtb failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: DTB image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )

    if "%device_has_recovery%" EQU "1" (
        if exist recovery.img (
            echo.
            echo ------ Flashing Recovery image ------
            !fastboot! -s !serial_number! flash recovery!slotsuffix! recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash recovery failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: Recovery image does not exist, but your device contain this partition, skip flashing.
            )
        )
    )

exit /b 0
