@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashAPartSuper
set /A failure_count=0

    REM This is a discriminant for super image.
    set /A A=0
    if exist super.img set /A A+=1
    if exist super.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different formats Super image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if "%skip_error_prompt%" NEQ "1" (
        if !A! EQU 0 (
            color fc
            echo.
            echo Fatal Error: Super image does not exist. This is obviously wrong, please check the firmware location path^^!
            exit /b 1
        )
    )
    REM if %A% EQU 1
    if exist super.img_sparsechunk* (
        echo.
        echo ------ Flashing sparse Super image ------
        REM Initialize the variable to 0.
        set flash_failed=0
        for /F "usebackq tokens=*" %%a in (`%%ls%% -1 super.img_sparsechunk.* ^|^ %%sort%% -n -k 3 -t . 2^>^&1`) do (
            echo.
            echo ==^> Flashing sparse Super image: %%a
            %fastboot% -s %serial_number% flash super %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo ------------------------------
                echo Fatal Error: fastboot flash %%a failed^^!
                echo ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            exit /b 1
        )
    ) else (
        if exist super.img (
            echo.
            echo ------ Flashing full Super image ------
            !fastboot! -s !serial_number! flash super super.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash super failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )

exit /b 0
