@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashBLPartQCOM
    REM This is a discriminant for GPT image.
    set /A A=0
    if exist gpt.bin set /A A+=1
    if exist diskmap.pit set /A A+=1
    if exist PGPT set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Different types GPT image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        echo.
        echo Warning: GPT image does not exist. Skip flashing...
    )
    REM if %A% EQU 1
    if exist gpt.bin (
        echo.
        echo ------ Flashing GPT image ------
        %fastboot% -s %serial_number% flash partition gpt.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash gpt failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    REM This is a discriminant for bootloader image.
    set /A A=0
    if exist motoboot.img set /A A+=1
    if exist bootloader.img set /A A+=1
    if exist bootloader.bin set /A A+=1
    if exist preloader.bin set /A A+=1
    if exist preloader.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types Bootloader image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        color fc
        echo.
        echo Fatal Error: Bootloader image does not exist. This is obviously wrong, please check the firmware location path!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist bootloader.img (
        echo.
        echo ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash bootloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    ) else (
        if exist motoboot.img (
            echo.
            echo ------ Flashing Motoboot image ------
            !fastboot! -s !serial_number! flash motoboot motoboot.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash motoboot failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )
    if exist bootloader.bin (
        echo.
        echo ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash bootloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

exit /b 0
