@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashBPartMTK
set /A failure_count=0

    REM This is a discriminant for modem image.
    set /A A=0
    if exist radio.img set /A A+=1
    if exist NON-HLOS.bin set /A A+=1
    if exist modem.bin set /A A+=1
    if exist md1img.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types Modem image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if "%skip_error_prompt%" NEQ "1" (
        if !A! EQU 0 (
            color fc
            echo.
            echo Fatal Error: Modem image does not exist. This is obviously wrong, please check the firmware location path!
            exit /b 1
        )
    )
    REM if %A% EQU 1

    if exist md1img.img (
        echo.
        echo ------ Flashing MD1IMG image ------
        %fastboot% -s %serial_number% flash md1img%slotsuffix% md1img.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash md1img failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    if "%device_has_md1img2%" EQU "1" (
        if exist md1img2.img (
            echo.
            echo ------ Flashing MD1IMG2 image ------
            !fastboot! -s !serial_number! flash md1img2!slotsuffix! md1img2.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash md1img2 failed^^!
                echo ------------------------------
            )
        ) else (
            if "!skip_error_prompt!" NEQ "1" (
                echo.
                echo Warning: MD1IMG2 image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )

exit /b 0
