@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:smartFlash
    set is_recovery_img=0
    set is_boot_img=0
    for /f "delims=" %%i in ('echo "%file%" 2^>^&1') do (
        echo %%i 2^>^&1 | %grep% -i "twrp-" >nul && set is_recovery_img=1
        echo %%i 2^>^&1 | %grep% -i "recovery." >nul && set is_recovery_img=1
        echo %%i 2^>^&1 | %grep% -i "magisk_patched" >nul && set is_boot_img=1
    )

    if "%is_recovery_img%" == "1" (
        call :smartFlashRecovery
        goto :end
    )

    if "%is_boot_img%" == "1" (
        call :runSmartFlash 4
        goto :end
    )

    REM unmatched files
    call :runSmartFlash 3
    goto :end
    
    :end
exit /b 0

:smartFlashRecovery
@title %title% %version% - Flash Recovery Options
    echo ================================================================================
    echo                                          Please choose:
    echo ================================================================================
    echo.
    echo. [1] Direct boot Recovery. Suitable for slot A/B partition devices without real Recovery partitions from 2017 to 2020.
    echo. [2] Flash to real Recovery partition. Suitable for devices with real Recovery partition.
    echo. [0] Exit flash tool
    echo --------------------------------------------------------------------------------
    echo.
    set selection=
    set /p selection= Please enter the option number: ^>^>
        if /i "%selection%"=="1" cls && call :runSmartFlash %selection% && exit /b 0
        if /i "%selection%"=="2" cls && call :runSmartFlash %selection% && exit /b 0
        if /i "%selection%"=="0" cls && exit

    cls && goto :smartFlashRecovery
exit /b 0
::
::
:runSmartFlash
set opts1=%1

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runSmartFlash.cmd" %opts1% %file%
            ) else (
                start cmd /k call "%~dp0runSmartFlash.cmd" %opts1% %file%
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Press any key to exit.
    pause > nul
    goto :exit

exit /b 0
:exit
exit
