@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runEraseData
color f9
@title %title% %version% - Factory reset [%serial_number%]

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    echo.
    echo ======== Factory reset ========

    call "%~dp0doFactoryReset.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] factory reset failed.
    ) else (
        if !failure_count! EQU 0 ( color f2 )
        echo.
        echo Device [%serial_number%] factory reset is complete. Total of %failure_count% errors.
    )

    echo.
    echo ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear


    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
