@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runEraseModemst
color f9
@title %title% %version% - Erase Modem Cache [%serial_number%]

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    if "%device_is_qcom%" EQU "1" (
        if "!device_has_modemst!" EQU "0" (
            echo.
            echo Note: Your device [!serial_number!] does not have modemst partitions, skip erasing...
        )
        if "!device_has_mdm1m9kefs!" EQU "0" (
            echo.
            echo Note: Your device [!serial_number!] does not have mdm1m9kefs partitions, skip erasing...
        )
    )

    if "%device_is_mtk%" EQU "1" (
        if "!device_has_nvdata!" EQU "0" (
            echo.
            echo Note: Your device [!serial_number!] does not have NVData partition, skip erasing...
        )
    )

    call "%~dp0doEraseModemst.cmd"

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
    ) else (
        if !failure_count! EQU 0 ( color f2 )
        echo.
        echo Device [%serial_number%] operation is complete. Total of %failure_count% errors.
    )

    echo.
    echo ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
