@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runSwitchSlot
color f9
@title %title% %version% - Changing to Slot %slot% [%serial_number%]
REM vars
set slot=
    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Slot is null.
        goto :tips
    ) else (
        set slot=%1
    )

    call "%~dp0getPartitionTable.cmd"

    if "%slot%" == "a" call :switchSlot %slot%
    if "%slot%" == "b" call :switchSlot %slot%

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
        echo.
        goto :tips
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:switchSlot
@title %title% %version% - Changing to Slot %slot% [%serial_number%]
    echo.
    echo ------ Changing to Slot %slot% ------
    %fastboot% -s %serial_number% set_active %slot%
    if %errorlevel% NEQ 0 (
        color fc
        echo ---------------------------
        echo Error: Change failed^^!
        echo ---------------------------
        exit /b 1
    )
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
